﻿using System;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using Silanis.ESL.SDK.Internal;
using Newtonsoft.Json;
using Silanis.ESL.API;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using Newtonsoft.Json.Linq;


public class SignerOrder
{
    private static String apiUrl = "https://sandbox.esignlive.com/api";
    private static String apiKey = "api_key";

    public static void Main(string[] args)
    {
        string jsonString = "{ \"documents\": [ { \"id\": \"doc1\", \"index\": 1, \"name\": \"First Document\" }, { \"id\": \"doc2\", \"index\": 2, \"name\": \"Second Document\" } ], \"name\": \"Document Workflow\", \"type\": \"PACKAGE\", \"status\": \"DRAFT\" }";
        StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

        byte[] fileByteArray1 = File.ReadAllBytes(@"DOC_FILE_PATH_1");
        ByteArrayContent content = new ByteArrayContent(fileByteArray1);

        byte[] fileByteArray2 = File.ReadAllBytes(@"DOC_FILE_PATH_2");
        ByteArrayContent content2 = new ByteArrayContent(fileByteArray2);

        content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
        content.Headers.ContentDisposition.Name = "\"file\"";
        content.Headers.ContentDisposition.FileName = "\"FIRST_DOC_NAME.pdf\"";
        content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

        content2.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
        content2.Headers.ContentDisposition.Name = "\"file\"";
        content2.Headers.ContentDisposition.FileName = "\"SECOND_DOC_NAME.pdf\"";
        content2.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

        MultipartFormDataContent form = new MultipartFormDataContent();
        form.Add(content, "\"file\"", "\"FIRST_DOC_NAME.pdf\"");
        form.Add(content2, "\"file\"", "\"SECOND_DOC_NAME.pdf\"");
        form.Add(jsonContent, "\"payload\"");

        HttpClient myClient = new HttpClient();
        myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
        myClient.DefaultRequestHeaders.Add("Accept", "application/json");

        var response = myClient.PostAsync(new Uri(apiUrl + "/packages/"), form).Result;
        Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
    }
}